import PlayerObject from "./Player";

interface Event {
  onPlayerJoin(player: PlayerObject): void;
  onPlayerLeave(player: PlayerObject): void;
  onTeamVictory(scores: Object): void;
  onPlayerChat(player: PlayerObject, message: string): void | Boolean;
  onPlayerBallKick(player: PlayerObject): void;
  onTeamGoal(player: PlayerObject): void;
  onGameStart(byPlayer: PlayerObject): void;
  onGameStop(byPlayer: PlayerObject): void;
  onPlayerAdminChange(changedPlayer: PlayerObject, byPlayer: PlayerObject): void;
  onPlayerTeamChange(changedPlayer: PlayerObject, byPlayer: PlayerObject): void;
  onPlayerKicked(
    kickedPlayer: PlayerObject,
    reason: string,
    ban: Boolean,
    byPlayer: PlayerObject
  ): void;
  onGameTick(): void;
  onGamePause(byPlayer: PlayerObject): void;
  onGameUnpause(byPlayer: PlayerObject): void;
  onPositionsReset(): void;
  onPlayerActivity(player: PlayerObject): void;
  onStadiumChange(newStadiumName: string, byPlayer: PlayerObject): void;
  onRoomLink(url: string): void;
  onKickRateLimitSet(
    min: number,
    rate: number,
    burst: number,
    byPlayer: PlayerObject
  ): void;
};

export default Event;
